<div id="body" class="container-fluid">
  <div class="row">
    <div class="col-24">
      <div class="row">
        <div class="col-md-6">
          <h6 class="mb-1">UCaaS</h6>
        </div>
        <div class="col-md-6 offset-md-12">
          <div class="text-right">
            <a target="_blank" rel="noopener noreferrer" href="http://webcontoo.corp.sprint.com/webcontoo/llisapi.dll/9280920/9280919_COWS_Event_Form__-_Job_Aid_for_Global_Cisco_HCS_%28UCaaS%29.pdf?func=doc.Fetch&nodeid=9280920&vernum=0">UCaaS Event Job Aid for IPMs/Members</a>
          </div>
        </div>
      </div>
      <h6 class="text-danger" *ngIf="isLocked">This event is currently locked by {{ lockedByUser }}</h6>
      <form [formGroup]="form" novalidate>
        <!-- Buttons -->
        <div class="form-row text-center">
          <div class="form-group form-group-sm col-12 col-md-6 col-lg-4 offset-md-6 offset-lg-8">
            <button type="button" class="btn btn-sm btn-secondary btn-block" (click)="cancel()">
              Cancel
            </button>
          </div>
          <div class="form-group form-group-sm col-12 col-md-6 col-lg-4"
               *ngIf="!isLocked && (isMember || isReviewer || isActivator)">
            <div *ngIf="editMode; then saveTemplate; else editTemplate;"></div>
            <ng-template #editTemplate>
              <button type="button" *ngIf="showEditButton"
                      class="btn btn-sm btn-primary btn-block" (click)="edit()">
                Edit Event
              </button>
            </ng-template>
            <ng-template #saveTemplate>
              <button type="button" class="btn btn-sm btn-primary btn-block" (click)="save()">
                Save
              </button>
            </ng-template>
          </div>
        </div>

        <!-- UCaaS Info -->
        <div class="form-row">
          <div class="form-group form-group-sm row col-24 col-lg-12">
            <label class="col-form-label col-24 col-lg-6">Event ID: </label>
            <div class="col-24 col-lg-16 pl-0 pl-lg-1">
              <div class="input-group">
                <input type="text" class="form-control form-control-sm" formControlName="eventID" />
                <a *ngIf="id > 0" class="hyperlink" (click)="onHistoryLookup()">Lookup Event History</a>
              </div>
            </div>
          </div>
          <div class="form-group form-group-sm row col-24 col-lg-12">
            <label class="col-form-label col-24 col-lg-6">Event Status: </label>
            <div class="col-24 col-lg-16 pl-0 pl-lg-1">
              <dx-select-box [items]="eventStatusList" formControlName="eventStatus"
                             displayExpr="description" valueExpr="value"></dx-select-box>
            </div>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group form-group-sm row col-24">
            <label class="col-form-label col-24 col-lg-3">Item Title: </label>
            <div class="col-24 col-lg-20 pl-0 pl-lg-1">
              <input type="text" class="form-control form-control-sm" formControlName="itemTitle" />
            </div>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group form-group-sm row col-24 col-lg-12">
            <label class="col-form-label col-24 col-lg-6 text-danger">H1: </label>
            <div class="col-24 col-lg-16 pl-0 pl-lg-1">
              <div class="input-group">
                <input type="text" class="form-control form-control-sm" formControlName="h1" (keyup)="handleWhiteSpaces($event, 'h1')" />
                <app-lookup-h1 [group]="form" [option]="option.lookup_h1"
                               *ngIf="option.lookup_h1?.isEnabled"
                               (result)="onH1LookupResult($event)"></app-lookup-h1>
              </div>
              <div *ngIf="h1.invalid && (h1.dirty || h1.touched || isSubmitted)">
                <span *ngIf="h1.errors.required" class="form-text text-danger">
                  H1 is required
                </span>
                <span *ngIf="h1.errors.invalidH1" class="form-text text-danger">
                  H1 field is not in correct format. H1 should contain 9 digits only.
                </span>
              </div>
            </div>
          </div>
          <div class="form-group form-group-sm row col-24 col-lg-12">
            <label class="col-form-label col-24 col-lg-6 text-danger">Customer Name: </label>
            <div class="col-24 col-lg-16 pl-0 pl-lg-1">
              <dx-select-box #ddCustomer [items]="odieRspnList" formControlName="customerName"
                             displayExpr="custNme" valueExpr="custNme"
                             placeholder="Please select a Customer"
                             [searchEnabled]="true" [searchExpr]="['custNme']" searchMode="startswith"
                             (onValueChanged)="onOdieCustomerNameChanged($event)"></dx-select-box>
              <div *ngIf="customerName.invalid && (customerName.dirty || customerName.touched || isSubmitted)">
                <span *ngIf="customerName.errors.required" class="form-text text-danger">
                  Customer Name is required
                </span>
              </div>
            </div>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group form-group-sm row col-24 col-lg-12">
            <label class="col-form-label col-24 col-lg-6 text-danger">UCaaS Product: </label>
            <div class="col-24 col-lg-16 pl-0 pl-lg-1">
              <dx-select-box [items]="ucaasProdTypeList" formControlName="ucaasProdType"
                             displayExpr="description" valueExpr="value"
                             [searchEnabled]="true" [searchExpr]="['description']"
                             searchMode="startswith"
                             (onSelectionChanged)="onUcaasProdTypeChanged($event)"></dx-select-box>
              <div *ngIf="ucaasProdType.invalid && (ucaasProdType.dirty || ucaasProdType.touched || isSubmitted)">
                <span *ngIf="ucaasProdType.errors.required" class="form-text text-danger">
                  UCaaS Product is required
                </span>
              </div>
            </div>
          </div>
          <div class="form-group form-group-sm row col-24 col-lg-12">
            <label class="col-form-label col-24 col-lg-6 text-danger">UCaaS Plan Type: </label>
            <div class="col-24 col-lg-16 pl-0 pl-lg-1">
              <dx-select-box [items]="ucaasPlanTypeList" formControlName="ucaasPlanType"
                             displayExpr="description" valueExpr="value"
                             [searchEnabled]="true" [searchExpr]="['description']"
                             searchMode="startswith"
                             (onSelectionChanged)="onUcaasPlanTypeChanged($event)"></dx-select-box>
              <div *ngIf="ucaasPlanType.invalid && (ucaasPlanType.dirty || ucaasPlanType.touched || isSubmitted)">
                <span *ngIf="ucaasPlanType.errors.required" class="form-text text-danger">
                  UCaaS Plan Type is required
                </span>
              </div>
            </div>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group form-group-sm row col-24 col-lg-12">
            <label class="col-form-label col-24 col-lg-6 text-danger">UCaaS Activity: </label>
            <div class="col-24 col-lg-16 pl-0 pl-lg-1">
              <dx-select-box [items]="ucaasActivityTypeList" formControlName="ucaasActivityType"
                             displayExpr="description" valueExpr="value"
                             [searchEnabled]="true" [searchExpr]="['description']"
                             searchMode="startswith"></dx-select-box>
              <div *ngIf="ucaasActivityType.invalid && (ucaasActivityType.dirty || ucaasActivityType.touched || isSubmitted)">
                <span *ngIf="ucaasActivityType.errors.required" class="form-text text-danger">
                  UCaaS Activity is required
                </span>
              </div>
            </div>
          </div>
          <div class="form-group form-group-sm row col-24 col-lg-12">
            <label class="col-form-label col-24 col-lg-6">CharsID: </label>
            <div class="col-24 col-lg-16 pl-0 pl-lg-1">
              <input type="text" class="form-control form-control-sm" formControlName="charsID" />
            </div>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group form-group-sm row col-24">
            <label class="col-form-label col-24 col-lg-3 text-danger">Team PDL: </label>
            <div class="col-24 col-lg-20 pl-0 pl-lg-1">
              <input type="text" class="form-control form-control-sm" formControlName="teamPdl" />
              <div *ngIf="teamPdl.invalid && (teamPdl.dirty || teamPdl.touched || isSubmitted)">
                <span *ngIf="teamPdl.errors.required" class="form-text text-danger">
                  Team PDL is required
                </span>
              </div>
            </div>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group form-group-sm row col-24">
            <label class="col-form-label col-24 col-lg-3 text-danger">Customer SOW: </label>
            <div class="col-24 col-lg-20 pl-0 pl-lg-1">
              <div class="input-group">
                <input type="text" class="form-control form-control-sm" formControlName="customerSow" />
                <button id="btnSowGo" type="button"
                        class="btn btn-sm btn-primary" (click)="openCustomerSow()">
                  Go
                </button>
              </div>
              <div *ngIf="customerSow.invalid && (customerSow.dirty || customerSow.touched || isSubmitted)">
                <span *ngIf="customerSow.errors.required" class="form-text text-danger">
                  Customer SOW is required
                </span>
              </div>
            </div>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group form-group-sm row col-24">
            <label class="col-form-label col-24 col-lg-3">
              UCaaS Design <span class="d-inline-block d-lg-none">Doc</span>
              <span class="d-none d-lg-inline-block">Document</span>:
            </label>
            <div class="col-24 col-lg-20 pl-0 pl-lg-1">
              <input type="text" class="form-control form-control-sm" formControlName="ucaasDesignDoc" />
            </div>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group form-group-sm row col-24">
            <label class="col-form-label col-24 col-lg-3 text-danger">
              Short <span class="d-inline-block d-lg-none">Desc</span>
              <span class="d-none d-lg-inline-block">Description</span>:
            </label>
            <div class="col-24 col-lg-20 pl-0 pl-lg-1">
              <textarea class="form-control form-control-sm" formControlName="shortDesc" rows="5"></textarea>
              <div *ngIf="shortDesc.invalid && (shortDesc.dirty || shortDesc.touched || isSubmitted)">
                <span *ngIf="shortDesc.errors.required" class="form-text text-danger">
                  Short Description is required
                </span>
              </div>
            </div>
          </div>
        </div>

        <!-- Redesign Device Information -->
        <mat-accordion *ngIf="ucaasActivityType.value != 3 && (ucaasProdType.value != 3 && ucaasProdType.value != 4 || id == 0)">
          <mat-expansion-panel [expanded]="!(ucaasRedesignDevInfoList.length > 0)" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>Redesign Device Information</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div class="mb-1 text-danger" *ngIf="showRedesignError">
              {{ h1ApprovedRedesignError }}
            </div>
            <button type="button" class="btn btn-sm btn-primary" [disabled]="!editMode"
                    (click)="reloadRedesign()" *ngIf="ucaasActivityType.value != 3">
              Reload Redesign Data
            </button>
            <div class="mb-1" *ngIf="odieRedesignDevInfoList.length > 0">
              <dx-data-grid #odieRedesignGrid id="odieRedesignGrid" [disabled]="!editMode"
                            [dataSource]="odieRedesignDevInfoList" keyExpr="redsgnDevId"
                            [showBorders]="true" [wordWrapEnabled]="true"
                            [rowAlternationEnabled]="true" [columnAutoWidth]="true"
                            (onSelectionChanged)="selectionOdieRedesignDev($event)">
                <dxo-sorting mode="multiple"></dxo-sorting>
                <dxo-selection mode="multiple" showCheckBoxesMode="always" selectAllMode="page"></dxo-selection>
                <dxo-scrolling mode="standard" showScrollbar="always" useNative="false"></dxo-scrolling>
                <dxi-column dataField="redesignNbr" caption="Redesign Number"
                            dataType="string" [minWidth]="150"></dxi-column>
                <dxi-column dataField="expirationDate" caption="Redesign Expiration Date"
                            dataType="string" [minWidth]="150"
                            cellTemplate="redesignExpirationDate"></dxi-column>
                <dxi-column dataField="devNme" caption="ODIE Device Name"
                            dataType="string" [minWidth]="150"></dxi-column>
                <dxi-column dataField="scCd" caption="Simple Complex Flag"
                            dataType="string" [minWidth]="100"></dxi-column>
                <div *dxTemplate="let cell of 'redesignExpirationDate'">
                  <span>{{cell.text | date:'MM/dd/yyyy hh:mm a'}}</span>
                </div>
              </dx-data-grid>
              <button type="button" class="btn btn-sm btn-primary mt-1" [disabled]="!editMode"
                      (click)="addSelectedOdieRedesignDevInfo()">
                Add Selected Rows
              </button>
            </div>
          </mat-expansion-panel>
        </mat-accordion>
        <mat-accordion *ngIf="ucaasRedesignDevInfoList.length > 0 && ucaasActivityType.value != 3 && !hideRedesignInfo">
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <dx-data-grid #redesignGrid id="redesignGrid" [dataSource]="ucaasRedesignDevInfoList"
                          [showBorders]="true" [wordWrapEnabled]="true" [disabled]="!editMode"
                          [rowAlternationEnabled]="true" [columnAutoWidth]="true"
                          (onEditorPreparing)="onVendorPreparing($event)">
              <dxo-sorting mode="multiple"></dxo-sorting>
              <dxo-editing mode="cell"
                           [allowUpdating]="true"
                           [allowDeleting]="true">
              </dxo-editing>
              <dxo-scrolling mode="standard" showScrollbar="always" useNative="false"></dxo-scrolling>
              <dxi-column dataField="rdsnNbr" caption="Redesign Number" dataType="string"
                          [allowEditing]="false" [minWidth]="150" headerCellTemplate="headerTemplate"></dxi-column>
              <dxi-column dataField="rdsnExpDt" caption="Redesign Expiration Date"
                          dataType="string" [minWidth]="150" [allowEditing]="false"
                          headerCellTemplate="headerTemplate" cellTemplate="redesignExpirationDate"></dxi-column>
              <dxi-column dataField="odieDevNme" caption="ODIE Device Name" dataType="string"
                          [allowEditing]="false" [minWidth]="150" headerCellTemplate="headerTemplate"></dxi-column>
              <dxi-column dataField="manfId" caption="Vendor" dataType="string"
                          [minWidth]="150" [setCellValue]="onVendorChange"
                          headerCellTemplate="headerTemplate">
                <dxo-lookup [dataSource]="deviceManfList" valueExpr="manfId" displayExpr="manfNme" [minWidth]="150">
                </dxo-lookup>
              </dxi-column>
              <dxi-column dataField="devModelId" caption="Model" dataType="string"
                          [minWidth]="150" headerCellTemplate="headerTemplate">
                <dxo-lookup [dataSource]="getDeviceModelByManfId" valueExpr="devModelId" displayExpr="devModelNme">
                </dxo-lookup>
              </dxi-column>
              <div *dxTemplate="let cell of 'redesignExpirationDate'">
                <span>{{cell.text | date:'MM/dd/yyyy hh:mm a'}}</span>
              </div>
              <div *dxTemplate="let header of 'headerTemplate'">
                <span class="text-danger">{{header.column.caption}}</span>
              </div>
            </dx-data-grid>
            <button type="button" class="btn btn-sm btn-primary mt-1" [disabled]="!editMode"
                    (click)="saveRedesignData()">
              Save Redesign/ODIE Table Data
            </button>
          </mat-expansion-panel>
        </mat-accordion>

        <!-- Site Information -->
        <mat-accordion *ngIf="ucaasActivityType.value != 3">
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>Site Information</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div formGroupName="site">
              <app-lookup-site [group]="form.controls.site" [option]="option.lookup_site"
                               [eventType]="eventType" [isSiteNoteVisible]="false"
                               [isSubmitted]="isSubmitted" (result)="onSiteLookupResult($event)">
              </app-lookup-site>

              <!-- Device Completion Table -->
              <mat-accordion *ngIf="isLookupSiteIdClicked || showDeviceCompleteTable">
                <mat-expansion-panel [expanded]="devCompletionList.length > 0" class="mb-1">
                  <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
                    <mat-panel-title><h6>Device Completion Table</h6></mat-panel-title>
                  </mat-expansion-panel-header>
                  <dx-data-grid #devComGrid id="devComGrid" [dataSource]="devCompletionList"
                                [showBorders]="true" [wordWrapEnabled]="true" [disabled]="!editMode"
                                [rowAlternationEnabled]="true" [columnAutoWidth]="true"
                                (onRowUpdated)="onDeviceCompletionRowUpdate($event)">
                    <dxo-sorting mode="multiple"></dxo-sorting>
                    <dxo-editing mode="cell" [allowUpdating]="true"></dxo-editing>
                    <dxo-paging [pageSize]="10"></dxo-paging>
                    <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[25, 50, 100]"></dxo-pager>
                    <dxo-scrolling mode="standard" showScrollbar="always" useNative="false"></dxo-scrolling>
                    <dxi-column dataField="odieDevNme" caption="ODIE Device Name" dataType="string"
                                [allowEditing]="false" headerCellTemplate="headerTemplate">
                      <dxo-lookup [dataSource]="ucaasRedesignDevInfoList" valueExpr="odieDevNme" displayExpr="odieDevNme">
                      </dxo-lookup>
                    </dxi-column>
                    <dxi-column dataField="h6" caption="ODIE H6" dataType="string"
                                headerCellTemplate="headerTemplate"></dxi-column>
                    <dxi-column dataField="cmpltdCd" caption="Activator Complete" dataType="boolean"
                                [allowEditing]="ucaasEvent?.eventStusId == 5 || ucaasEvent?.eventStusId == 6"></dxi-column>
                    <div *dxTemplate="let header of 'headerTemplate'">
                      <span class="text-danger">{{header.column.caption}}</span>
                    </div>
                  </dx-data-grid>
                </mat-expansion-panel>
              </mat-accordion>

              <!-- CPE Table -->
              <mat-accordion *ngIf="isLookupSiteIdClicked">
                <mat-expansion-panel [expanded]="ucaasEventCpeDevList.length > 0" class="mb-1">
                  <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
                    <mat-panel-title><h6>CPE Table</h6></mat-panel-title>
                  </mat-expansion-panel-header>
                  <dx-data-grid #gridCpe id="gridCpe" [dataSource]="ucaasEventCpeDevList"
                                [wordWrapEnabled]="true" [showBorders]="true"
                                [rowAlternationEnabled]="true" [columnAutoWidth]="true" [disabled]="!editMode">
                    <dxo-sorting mode="multiple"></dxo-sorting>
                    <dxo-editing mode="cell" [allowUpdating]="true"></dxo-editing>
                    <dxo-scrolling mode="standard" showScrollbar="always" useNative="false"></dxo-scrolling>
                    <dxi-column dataField="odieCd" caption="Ignore ODIE" dataType="boolean"></dxi-column>
                    <dxi-column dataField="cpeOrdrNbr" caption="CPE Order #"
                                dataType="string" [allowEditing]="false"></dxi-column>
                    <dxi-column dataField="deviceId" caption="Device ID"
                                dataType="string" [allowEditing]="false"></dxi-column>
                    <dxi-column dataField="assocH6" caption="Associated H6"
                                dataType="string" [allowEditing]="false"></dxi-column>
                    <dxi-column dataField="reqstnNbr" caption="Requisition #"
                                dataType="string" [allowEditing]="false"></dxi-column>
                    <dxi-column dataField="odieDevNme" caption="ODIE Device Name" dataType="string"
                                headerCellTemplate="headerTemplate">
                      <dxo-lookup [dataSource]="ucaasRedesignDevInfoList"
                                  valueExpr="odieDevNme" displayExpr="odieDevNme">
                      </dxo-lookup>
                    </dxi-column>
                    <dxi-column cellTemplate="cellTemplate"></dxi-column>
                    <div *dxTemplate="let cell of 'cellTemplate'">
                      <a href="#" (click)="onViewOrderDetail($event, cell.data)">View Order Detail</a>
                    </div>
                    <div *dxTemplate="let header of 'headerTemplate'">
                      <span class="text-danger">{{header.column.caption}}</span>
                    </div>
                  </dx-data-grid>
                </mat-expansion-panel>
              </mat-accordion>

              <!-- Device Based MNS Management Service Table -->
              <mat-accordion *ngIf="isLookupSiteIdClicked">
                <mat-expansion-panel [expanded]="deviceSrvcMngmtList.length > 0" class="mb-1">
                  <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
                    <mat-panel-title><h6>Device Based MNS Management Service Table</h6></mat-panel-title>
                  </mat-expansion-panel-header><!--keyExpr="devSrvcMgmtID"-->
                  <dx-data-grid #gridDeviceSrvcMngmt id="gridDeviceSrvcMngmt"
                                [dataSource]="deviceSrvcMngmtList"
                                [wordWrapEnabled]="true" [showBorders]="true" [disabled]="!editMode"
                                [rowAlternationEnabled]="true" [columnAutoWidth]="true">
                    <dxo-sorting mode="multiple"></dxo-sorting>
                    <dxo-editing mode="cell" [allowUpdating]="true"></dxo-editing>
                    <dxo-scrolling mode="standard" showScrollbar="always" useNative="false"></dxo-scrolling>
                    <dxi-column dataField="odieCd" caption="Ignore ODIE" dataType="boolean"></dxi-column>
                    <dxi-column dataField="deviceID" caption="Device ID"
                                dataType="string" [allowEditing]="false"></dxi-column>
                    <dxi-column dataField="mnsSrvcTierId" caption="Service Tier" dataType="string"
                                headerCellTemplate="headerTemplate">
                      <dxo-lookup [dataSource]="serviceTierList" valueExpr="value" displayExpr="description">
                      </dxo-lookup>
                    </dxi-column>
                    <dxi-column dataField="odieDevNme" caption="ODIE Device Name" dataType="string"
                                headerCellTemplate="headerTemplate">
                      <dxo-lookup [dataSource]="ucaasRedesignDevInfoList"
                                  valueExpr="odieDevNme" displayExpr="odieDevNme">
                      </dxo-lookup>
                    </dxi-column>
                    <div *dxTemplate="let header of 'headerTemplate'">
                      <span class="text-danger">{{header.column.caption}}</span>
                    </div>
                  </dx-data-grid>
                </mat-expansion-panel>
              </mat-accordion>

              <!-- Billing Table -->
              <mat-accordion *ngIf="(ucaasProdType.value == 1 && (ucaasPlanType.value == 1 || ucaasPlanType.value == 4))
                             || (ucaasProdType.value == 2 && (ucaasPlanType.value == 1 || ucaasPlanType.value == 4) && (ucaasActivityType.value == 4 || ucaasActivityType.value == 5 || ucaasActivityType.value == 6))">
                <mat-expansion-panel [expanded]="true" class="mb-1">
                  <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
                    <mat-panel-title><h6>Billing Table</h6></mat-panel-title>
                  </mat-expansion-panel-header>
                  <dx-data-grid #gridBilling id="gridBilling" [disabled]="!editMode"
                                [dataSource]="ucaasBillActivityList"
                                [wordWrapEnabled]="true" [showBorders]="true"
                                [rowAlternationEnabled]="true" [columnAutoWidth]="true">
                    <dxo-sorting mode="multiple"></dxo-sorting>
                    <dxo-editing mode="cell" [allowUpdating]="true"></dxo-editing>
                    <dxo-scrolling mode="standard" showScrollbar="always" useNative="false"></dxo-scrolling>
                    <dxi-column dataField="incQty" caption="Quantity" dataType="number" alignment="left"
                                [visible]="ucaasActivityType.value == 1"></dxi-column>
                    <dxi-column dataField="incQty" caption="Increase Qty" dataType="number" alignment="left"
                                [visible]="ucaasActivityType.value != 1"></dxi-column>
                    <dxi-column dataField="dcrQty" caption="Decrease Qty" dataType="number" alignment="left"
                                [visible]="ucaasActivityType.value != 1"></dxi-column>
                    <dxi-column dataField="ucaaSBillActyDes" caption="Description"
                                dataType="string" [allowEditing]="false"></dxi-column>
                    <dxi-column dataField="ucaaSBicType" caption="BIC" dataType="string"
                                [allowEditing]="false"></dxi-column>
                    <dxi-column dataField="mrcNrcCd" caption="MRC/NRC" dataType="string"
                                [allowEditing]="false"></dxi-column>
                  </dx-data-grid>
                </mat-expansion-panel>
              </mat-accordion>

              <div class="row">
                <!-- Install Site -->
                <div formGroupName="installSite" class="col-12 pr-1">
                  <div class="form-row">
                    <div class="form-group form-group-sm row col-24">
                      <label class="col-form-label col-6 text-danger">Install Site POC: </label>
                      <div class="col-16 pl-0 pl-lg-1">
                        <input type="text" class="form-control form-control-sm" formControlName="poc" />
                      </div>
                    </div>
                  </div>
                  <div class="form-row">
                    <div class="form-group form-group-sm row col-24">
                      <label class="col-form-label col-6 text-danger">Phone: </label>
                      <div class="col-5 pl-0 pl-lg-1 pr-lg-1">
                        <input type="text" class="form-control form-control-sm" formControlName="phoneCode" />
                      </div>
                      <div class="col-11 pl-0">
                        <input type="text" class="form-control form-control-sm" formControlName="phone" />
                      </div>
                    </div>
                  </div>
                  <div class="form-row">
                    <div class="form-group form-group-sm row col-24">
                      <label class="col-form-label col-6">Cellphone: </label>
                      <div class="col-5 pl-0 pl-lg-1 pr-lg-1">
                        <input type="text" class="form-control form-control-sm" formControlName="cellphoneCode" />
                      </div>
                      <div class="col-11 pl-0">
                        <input type="text" class="form-control form-control-sm" formControlName="cellphone" />
                      </div>
                    </div>
                  </div>
                </div>
                <!-- Service Assurance -->
                <div formGroupName="serviceAssurance" class="col-12 pr-1">
                  <div class="form-row">
                    <div class="form-group form-group-sm row col-24">
                      <label class="col-form-label col-6 text-danger">Service Assurance POC: </label>
                      <div class="col-16 pl-0 pl-lg-1">
                        <input type="text" class="form-control form-control-sm" formControlName="poc" />
                      </div>
                    </div>
                  </div>
                  <div class="form-row">
                    <div class="form-group form-group-sm row col-24">
                      <label class="col-form-label col-6 text-danger">Phone: </label>
                      <div class="col-5 pl-0 pl-lg-1 pr-lg-1">
                        <input type="text" class="form-control form-control-sm" formControlName="phoneCode" />
                      </div>
                      <div class="col-11 pl-0">
                        <input type="text" class="form-control form-control-sm" formControlName="phone" />
                      </div>
                    </div>
                  </div>
                  <div class="form-row">
                    <div class="form-group form-group-sm row col-24">
                      <label class="col-form-label col-6">Cellphone: </label>
                      <div class="col-5 pl-0 pl-lg-1 pr-lg-1">
                        <input type="text" class="form-control form-control-sm" formControlName="cellphoneCode" />
                      </div>
                      <div class="col-11 pl-0">
                        <input type="text" class="form-control form-control-sm" formControlName="cellphone" />
                      </div>
                    </div>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24 col-lg-12">
                  <label class="col-form-label col-24 col-lg-6 text-danger">Address: </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="address" />
                  </div>
                </div>
                <div class="form-group form-group-sm row col-24 col-lg-12">
                  <label class="col-form-label col-24 col-lg-6 text-danger">State/Province: </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="state" />
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24 col-lg-12">
                  <label class="col-form-label col-24 col-lg-6">Bldg/Floor/Room: </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="bldg_flr_rm" />
                  </div>
                </div>
                <div class="form-group form-group-sm row col-24 col-lg-12">
                  <label class="col-form-label col-24 col-lg-6 text-danger">Country: </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="country" />
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24 col-lg-12">
                  <label class="col-form-label col-24 col-lg-6 text-danger">City: </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="city" />
                  </div>
                </div>
                <div class="form-group form-group-sm row col-24 col-lg-12">
                  <label class="col-form-label col-24 col-lg-6 text-danger">Zip Code: </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="zip" />
                  </div>
                </div>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>

        <!-- CPE Delivery Options -->
        <mat-accordion *ngIf="ucaasActivityType.value != 3">
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>CPE Delivery Options</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div formGroupName="cpe">
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-3 text-danger">CPE Delivery Options: </label>
                  <div class="col-24 col-lg-20 pl-0 pl-lg-1">
                    <dx-select-box [items]="cpeDeliveryOptionList" formControlName="cpeDeliveryOption"
                                   displayExpr="description" valueExpr="value"
                                   [searchEnabled]="true" [searchExpr]="['description']"
                                   searchMode="startswith"></dx-select-box>
                    <div *ngIf="cpeDeliveryOption.invalid
                         && (cpeDeliveryOption.dirty || cpeDeliveryOption.touched || isSubmitted)">
                      <span *ngIf="cpeDeliveryOption.errors.required && ucaasActivityType.value != 3"
                            class="form-text text-danger">
                        CPE Delivery Options is required
                      </span>
                    </div>
                  </div>
                </div>
              </div>
              <div class="form-row" *ngIf="cpeDeliveryOption.value == 2 || cpeDeliveryOption.value == 9">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-3 text-danger">CPE Dispatch Email Address: </label>
                  <div class="col-24 col-lg-20 pl-0 pl-lg-1">
                    <input type="text" class="form-control form-control-sm" formControlName="cpeDispatchEmail" />
                    <div *ngIf="cpeDispatchEmail.invalid
                         && (cpeDispatchEmail.dirty || cpeDispatchEmail.touched || isSubmitted)">
                      <span *ngIf="cpeDispatchEmail.errors.required
                            && (cpeDeliveryOption.value == 2 || cpeDeliveryOption.value == 9)"
                            class="form-text text-danger">
                        CPE Dispatch Email Address is required
                      </span>
                    </div>
                  </div>
                </div>
              </div>
              <div class="form-row" *ngIf="cpeDeliveryOption.value == 2 || cpeDeliveryOption.value == 9">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-3 text-danger">CPE Dispatch Comments: </label>
                  <div class="col-24 col-lg-20 pl-0 pl-lg-1">
                    <textarea class="form-control form-control-sm" formControlName="cpeDispatchComments" rows="5"></textarea>
                    <div *ngIf="cpeDispatchComments.invalid
                         && (cpeDispatchComments.dirty || cpeDispatchComments.touched || isSubmitted)">
                      <span *ngIf="cpeDispatchComments.errors.required
                            && (cpeDeliveryOption.value == 2 || cpeDeliveryOption.value == 9)"
                            class="form-text text-danger">
                        CPE Dispatch Comments is required
                      </span>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>

        <!-- Managed Activity Table -->
        <mat-accordion *ngIf="ucaasActivityType.value == 3">
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>Managed Activity Table</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div class="mb-1 text-danger" *ngIf="showDiscoDevError">
              ODIE returned no recs for these Devices.
            </div>
            <dx-data-grid #gridManagedActTable id="gridManagedActTable"
                          [dataSource]="odieDiscoDevList"
                          [wordWrapEnabled]="true" [showBorders]="true"
                          [rowAlternationEnabled]="true" [columnAutoWidth]="true"
                          (onEditorPreparing)="onVendorPreparing($event)"
                          (onRowUpdated)="onVendorUpdate($event)"
                          (onToolbarPreparing)="onMngdActyToolbarPreparing($event)">
              <dxo-sorting mode="multiple"></dxo-sorting>
              <dxo-editing mode="row"
                           [allowUpdating]="true"
                           [allowDeleting]="true"
                           [allowAdding]="true">
              </dxo-editing>
              <dxo-scrolling mode="standard" showScrollbar="always" useNative="false"></dxo-scrolling>
              <dxi-column dataField="odieDevNme" caption="ODIE Device Name" dataType="string"
                          headerCellTemplate="headerTemplate">
                <dxi-validation-rule type="required"></dxi-validation-rule>
              </dxi-column>
              <dxi-column dataField="h5H6" caption="H6" dataType="string"
                          headerCellTemplate="headerTemplate">
                <dxi-validation-rule type="required"></dxi-validation-rule>
              </dxi-column>
              <dxi-column dataField="siteId" caption="Site ID" dataType="string"></dxi-column>
              <dxi-column dataField="deviceId" caption="Device ID" dataType="string"></dxi-column>
              <dxi-column dataField="manfId" caption="Vendor" dataType="string" [minWidth]="150"
                          headerCellTemplate="headerTemplate" [setCellValue]="onVendorChange">
                <dxo-lookup [dataSource]="deviceManfList" [minWidth]="150"
                            valueExpr="manfId" displayExpr="manfNme">
                </dxo-lookup>
              </dxi-column>
              <dxi-column dataField="devModelId" caption="Model" dataType="string" [minWidth]="150"
                          headerCellTemplate="headerTemplate">
                <dxo-lookup [dataSource]="getDeviceModelByManfId"
                            valueExpr="devModelId" displayExpr="devModelNme">
                </dxo-lookup>
              </dxi-column>
              <dxi-column dataField="serialNbr" caption="Serial Number" dataType="string"></dxi-column>
              <dxi-column dataField="thrdPartyCtrct" caption="Third Party Contract #"
                          dataType="string" [allowEditing]="false"></dxi-column>
              <div *dxTemplate="let header of 'headerTemplate'">
                <span class="text-danger">{{header.column.caption}}</span>
              </div>
              <div *dxTemplate="let data of 'retrieveOdieTemplate'">
                <button type="button" class="btn btn-sm btn-primary" (click)="getOdieDiscoData()">
                  Retrieve ODIE Data
                </button>
              </div>
            </dx-data-grid>
          </mat-expansion-panel>
        </mat-accordion>

        <!-- Disconnect Information -->
        <mat-accordion *ngIf="ucaasActivityType.value == 3">
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>Disconnect Information</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div formGroupName="disconnectInfo">
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-6 text-danger">Disconnect of Management Only?</label>
                  <div class="col-24 col-lg-18 pl-0 pl-lg-1">
                    <dx-select-box [items]="disconnectMgmtOnlyList"
                                   displayExpr="description" valueExpr="value"
                                   [searchEnabled]="true" [searchExpr]="['description']"
                                   searchMode="startswith"
                                   formControlName="disconnectMgmtOnly"></dx-select-box>
                    <div *ngIf="disconnectMgmtOnly.invalid &&
                         (disconnectMgmtOnly.dirty || disconnectMgmtOnly.touched || isSubmitted)">
                      <span *ngIf="disconnectMgmtOnly.errors.required" class="form-text text-danger">
                        Disconnect of Management Only is required
                      </span>
                    </div>
                  </div>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24">
                  <label class="col-form-label col-24 col-lg-6 text-danger">Is this a total customer disconnect?</label>
                  <div class="col-24 col-lg-18 pl-0 pl-lg-1">
                    <dx-select-box [items]="totalCustDisconnectList"
                                   displayExpr="description" valueExpr="value"
                                   [searchEnabled]="true" [searchExpr]="['description']"
                                   searchMode="startswith"
                                   formControlName="totalCustDisconnect"></dx-select-box>
                    <div *ngIf="totalCustDisconnect.invalid &&
                         (totalCustDisconnect.dirty || totalCustDisconnect.touched || isSubmitted)">
                      <span *ngIf="totalCustDisconnect.errors.required" class="form-text text-danger">
                        Total customer disconnect is required
                      </span>
                    </div>
                  </div>
                </div>
              </div>
              <div class="form-row" *ngIf="totalCustDisconnect.value != null">
                <div class="form-group form-group-sm row col-24">
                  <label *ngIf="totalCustDisconnect.value == 1"
                         class="col-form-label col-24 col-lg-6 text-danger">Reason for total customer disconnect?</label>
                  <label *ngIf="totalCustDisconnect.value == 0"
                         class="col-form-label col-24 col-lg-6 text-danger">Disconnect Short Description:</label>
                  <div class="col-24 col-lg-18 pl-0 pl-lg-1">
                    <textarea class="form-control form-control-sm" formControlName="disconnectReasonDesc" rows="5"></textarea>
                    <div *ngIf="disconnectReasonDesc.invalid &&
                         (disconnectReasonDesc.dirty || disconnectReasonDesc.touched || isSubmitted)">
                      <span *ngIf="disconnectReasonDesc.errors.required" class="form-text text-danger">
                        <span *ngIf="totalCustDisconnect.value == 1">Reason for total customer disconnect</span>
                        <span *ngIf="totalCustDisconnect.value == 0">Disconnect Short Description</span> is required
                      </span>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>

        <!-- Site Status -->
        <mat-accordion>
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>Site Status</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div formGroupName="siteStatus">
              <app-escalation-template [group]="form.controls.siteStatus" [option]="option.siteStatus"
                                       (result)="onConfBridgeResult($event)"></app-escalation-template>
              <div class="form-row">
                <div class="form-group form-group-sm row col-24 col-lg-12">
                  <label class="col-form-label col-24 col-lg-6">Published Email CC: </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <div class="input-group">
                      <input type="text" class="form-control form-control-sm" formControlName="publishedEmailCC" />
                      <app-user-finder id="published-email" [group]="form.controls.siteStatus"
                                       *ngIf="option.siteStatus.userFinderForPublishedEmail?.isEnabled"
                                       [option]="option.siteStatus.userFinderForPublishedEmail"></app-user-finder>
                    </div>
                  </div>
                </div>
                <div class="form-group form-group-sm row col-24 col-lg-12">
                  <label class="col-form-label col-24 col-lg-6">Completed Email CC: </label>
                  <div class="col-24 col-lg-16 pl-0 pl-lg-1">
                    <div class="input-group">
                      <input type="text" class="form-control form-control-sm" formControlName="completeEmailCC" />
                      <app-user-finder id="complete-email" [group]="form.controls.siteStatus"
                                       *ngIf="option.siteStatus.userFinderForCompleteEmail?.isEnabled"
                                       [option]="option.siteStatus.userFinderForCompleteEmail"></app-user-finder>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>

        <app-requestor-template [group]="form.controls.requestor" [option]="option.requestor"
                                [isSubmitted]="isSubmitted"></app-requestor-template>

        <app-schedule-template [group]="form" [option]="option" [eventType]="eventType" [eventId]="id"
                               [isReviewer]="isReviewer && editMode">
        </app-schedule-template>

        <!-- Workflow and Suppress Email -->
        <div class="form-row">
          <div class="form-group form-group-sm row col-24 col-lg-12">
            <label class="col-form-label col-24 col-lg-6">Workflow Status: </label>
            <div class="col-24 col-lg-16 pl-0 pl-lg-1">
              <dx-select-box [items]="workflowStatusList" formControlName="workflowStatus"
                             displayExpr="wrkflwStusDes" valueExpr="wrkflwStusId"
                             [searchEnabled]="true" [searchExpr]="['wrkflwStusDes']"
                             searchMode="startswith"></dx-select-box>
            </div>
          </div>
        </div>
        <div class="form-row" *ngIf="isReviewer">
          <div class="form-group form-group-sm row col-24 col-lg-12">
            <label class="col-form-label col-24 col-lg-6">Suppress Emails: </label>
            <div class="col-24 col-lg-16 pl-0 pl-lg-1">
              <dx-check-box formControlName="suppressEmail"></dx-check-box>
            </div>
          </div>
        </div>
        <!--<div class="form-row" *ngIf="profile == 'Activator'">
          <div class="form-group form-group-sm row col-24 col-lg-12">
            <label class="col-form-label col-24 col-lg-8">UCaaS Fail Codes: </label>
            <div class="col-24 col-lg-16 pl-0 pl-lg-1">
              <dx-select-box [items]="workflowStatusList"
                             displayExpr="wrkflwStusDes"
                             valueExpr="wrkflwStusId"
                             formControlName="failCode"></dx-select-box>
            </div>
          </div>
        </div>-->

        <app-event-history-template *ngIf="id > 0" [id]="id" [accordion]="true" [expanded]="!isMember"></app-event-history-template>

        <div class="form-row text-center mt-1">
          <div class="form-group form-group-sm col-12 col-md-6 col-lg-4 offset-md-6 offset-lg-8">
            <button type="button" class="btn btn-sm btn-secondary btn-block" (click)="cancel()">
              Cancel
            </button>
          </div>
          <div class="form-group form-group-sm col-12 col-md-6 col-lg-4"
               *ngIf="!isLocked && (isMember || isReviewer || isActivator)">
            <div *ngIf="editMode; then saveTemplate; else editTemplate;"></div>
            <ng-template #editTemplate>
              <button type="button" *ngIf="showEditButton"
                      class="btn btn-sm btn-primary btn-block" (click)="edit()">
                Edit Event
              </button>
            </ng-template>
            <ng-template #saveTemplate>
              <button type="button" class="btn btn-sm btn-primary btn-block" (click)="save()">
                Save
              </button>
            </ng-template>
          </div>
        </div>
      </form>
    </div>
  </div>
</div>

<app-validation-summary [errors]="errors" [option]="option.validationSummaryOptions"></app-validation-summary>

<div class="modal fade" id="viewCpeOrderDetails" tabindex="-1" role="dialog" aria-hidden="true">
  <div class="modal-dialog modal-xl" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title">CPE Equipment Order Information Summary</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
        <div class="mb-3">
          <dx-data-grid #cpeDeviceGrid id="cpeDeviceGrid" [dataSource]="modalCpeDeviceList"
                        [wordWrapEnabled]="true" [showBorders]="true"
                        [rowAlternationEnabled]="true" [columnAutoWidth]="true">
            <dxo-sorting mode="multiple"></dxo-sorting>
            <dxo-scrolling mode="standard" showScrollbar="always" useNative="false"></dxo-scrolling>
            <dxi-column dataField="devID" caption="Device ID" dataType="string"></dxi-column>
            <dxi-column dataField="odieDevNme" caption="ODIE Device Name" dataType="string"></dxi-column>
          </dx-data-grid>
        </div>

        <div class="mb-3">
          <h6>Pending Components</h6>
          <dx-data-grid #pendingCompGrid id="pendingCompGrid" [dataSource]="modalPendingComponentList"
                        [wordWrapEnabled]="true" [showBorders]="true"
                        [rowAlternationEnabled]="true" [columnAutoWidth]="true">
            <dxo-sorting mode="multiple"></dxo-sorting>
            <dxo-scrolling mode="standard" showScrollbar="always" useNative="false"></dxo-scrolling>
            <dxi-column dataField="devID" caption="Device ID:" [groupIndex]="0"></dxi-column>
            <dxi-column dataField="m5CPEOrdrNbr" caption="CPE Order #" dataType="string"></dxi-column>
            <dxi-column dataField="orderQty" caption="Qty" dataType="string"></dxi-column>
            <dxi-column dataField="descrption" caption="Description" dataType="string"></dxi-column>
            <dxi-column dataField="cntrctType" caption="Contract Type" dataType="string"></dxi-column>
            <dxi-column dataField="cPECmpntFmly" caption="Component Family" dataType="string"></dxi-column>
            <dxi-column dataField="vndrPO" caption="Vendor PO" dataType="string"></dxi-column>
            <dxi-column dataField="equipRcvdDt" caption="Equipment Received Date" dataType="string"></dxi-column>
            <dxi-column dataField="rcptStus" caption="Receipt Status" dataType="string"></dxi-column>
            <dxi-column dataField="recordOnly" caption="Record Only" dataType="string"></dxi-column>
          </dx-data-grid>
        </div>

        <div class="mb-3">
          <h6>Installed Inventory</h6>
          <dx-data-grid #installInvGrid id="installInvGrid" [dataSource]="modalInstalledInventoryList"
                        [wordWrapEnabled]="true" [showBorders]="true"
                        [rowAlternationEnabled]="true" [columnAutoWidth]="true">
            <dxo-sorting mode="multiple"></dxo-sorting>
            <dxo-scrolling mode="standard" showScrollbar="always" useNative="false"></dxo-scrolling>
            <dxi-column dataField="cpE_DEVICE_ID" caption="Device ID: " [groupIndex]="0"></dxi-column>
            <dxi-column dataField="ordeR_NBR" caption="Order ID" dataType="string"></dxi-column>
            <dxi-column dataField="nme" caption="Description" dataType="string"></dxi-column>
            <dxi-column dataField="insT_DT" caption="Install Date" dataType="date"></dxi-column>
          </dx-data-grid>
        </div>
      </div>
    </div>
  </div>
</div>
